<!DOCTYPE html>
<html>
	<head>
		<title>NINJA &raquo; DOJO &raquo; Dev. Manual</title>
		<style type="text/css">
			body {
				font: normal normal 11pt 'Century Gothic', 'Lucida Grande', sans-serif;
				padding: 16px 32px;
				margin: 0;
				width: 768px;
				background: #f5f5f5;
			}
			h1, h2, h3, h4 {
				color: #666;
				font-weight: normal;
				margin: 8px 0;
			}
			p {
				color: #444;
				margin: 4px 16px;
			}
			code {
				display: block;
				margin: 16px 32px;
				padding: 8px;
				font-size: 90%;
				border: 2px dotted #ddd;
				background: #eee;
				color: #555;
			}

			table {
				border: 2px solid #ccc;
				border-right: none;
				border-bottom: none;
				margin: 16px 32px;
				padding: 0;
				border-spacing: 0;
			}

			tr {
				padding: 0;
				margin: 0;
				border-spacing: 0;
			}

			td {
				border-spacing: 0;
				margin: 0;
				padding: 4px;
				color: #444;
				background: #eee;
				border-right: 2px solid #ccc;
				border-bottom: 2px solid #ccc;
				font-size: 90%;
			}

			div {
				margin-left: 16px;
			}

			.warning, .note, .critical {
				font-style: normal;
				color: #222;
				margin: 16px 32px;
				padding: 8px;
				overflow: auto;
			}

			a, a:visited, a:active {
				color: #47f;
				text-decoration: none;
			}

			a:hover {
				border-bottom: 1px dotted #47f;
			}

			.warning {
				background: #fd9;
				border: 2px solid #fa7;
			}

			.note {
				background: #ada;
				border: 2px solid #7b7;
			}

			.critical {
				background: #daa;
				border: 2px solid #c44;
			}

			.warning em, .note em, .critical em {
				font-style: normal;
				font-weight: bold;
				font-size: 11pt;
				padding: 0 6px;
				float: left;
			}

		</style>
	</head>
	<body>
		<h1>Ninja &raquo; DOJO &raquo; Dev. Manual</h1>
		
		<p>
			This manual is about the new layout DOJO for the Nagios GUI NINJA.
		</p>

		<p>
			DOJO aims to improve the structure, style and semantics of NINJA. Making the layout more dynamic, responsive and remove deprecated
			ways of handling layout.
		</p>

		<div class="critical">
			<em>(X) Critical: </em>
				DOJO will effectively make all custom skins unusable due to its enourmous changes to CSS, newly released skins for
				ninja include default, classic and hello kitty.
		</div>

		<div class="critical">
			<em>(X) Critical: </em>
				DOJO enforces the earlier experimental NOC behaviour on ninja, it cannot be switched back to the older sidebar menu.
		</div>

		<h2>Layout</h2>

		<div>

			<h3>Menus</h3>

			<p>
				The menus have move from a sidebar style to a drop-down behaviour (earlier experimental NOC) to give the data as much space as possible.
				Some menu-items have been moved (host problems, service problems and unhandled problems) to a joined unhandled problems quickbar icon.
			</p>

			<h3>Quickbar</h3>

			<p>
				The quickbar contains some of the older top-bar icons and functionality, such as settings and refresh but has been extended with
				a shortcut to unhandled problems and tactical overview. In ninja it also links to this documentation.
			</p>

			<p>
				The aim with the quickbar is that all customers should be able to pin menu items, filtered/saved searches and external links to an icon 
				in the topbar for easy access to as much as possible based on their needs.
			</p>

		</div>

		<h2>Install SASS</h2>

		<div class="note">
					<em>Note: </em>
					All developers must install SASS and Compass since we don't keep the compiled CSS in the repos, only SASS.
				</div>
		</div>

		<p>
			In order to install sass and compass, run the make:
		</p>

		<code>
			make install-sass
		</code>

		<p>
			Or install the gems manually through
		</p>

		<code>
			gem install sass (may need to sudo)<br />
			gem install compass (may need to sudo)<br />
		</code>

		<p>
			Once installed you can proceed to browse to the skin folder of your choice and type 
			in the compass command.
		</p>

		<code>
			cd ~/&lt;repo&gt;/monitor/ninja/application/views/css/default<br />
			compass watch
		</code>

		<p>
			Compass will poll for any changes to the SASS and compile to CSS, if no CSS is found it will do a first time 
			compilation initially.
		</p>

		<p>
			Or you can run the command make in the root directory after each SASS change
		</p>

		<code>
			make
		</code>

		<div class="critical">
					<em>(X) Critical: </em><br />
					<ul>
						<li>Never push CSS, only SASS</li>
						<li>Never change CSS only SASS</li>
					</ul>
				</div>
		<div>

			<h2>CSS</h2>
			
			<div>

				<h3>SASS syntax</h3>

				<p>
					SASS is a white-space sensitive indentation hierarchy language that does not use curly brackets or semi-colons as in regular CSS.
					It has support for inheritance, nesting, variables and "mixins".
				</p>

				<div>
					
					<h3>SASS quick guide</h3>
					
					<h4>
						Variables
					</h4>

					<p>
						Variables in SASS are denoted using the dollar-sign and are assigned using the colon, they contain CSS values, i.e. not pure
						numbers and text but type-specific values and can be used in place of any comparative value type.
					</p>

					<code>
						$fontF: "Verdana"<br />
						$fontS: 16pt<br />
						$fontW: bold<br />
						<br />
						p<br />
						&nbsp;&nbsp;font: $fontS $fontW normal $fontF<br />
					</code>

					<h4>
						Nesting
					</h4>

					<p>
						In regular CSS there is no nesting, if we want to declare a style to a parent, its children and their children, we have to create 
						three independent scopes
					</p>

					<code>
						.container {<br />
						&nbsp;&nbsp;properties...<br />
						}<br />
						.container .content {<br />
						&nbsp;&nbsp;properties...<br />
						}<br />
						.container .content span {<br />
						&nbsp;&nbsp;properties...<br />
						}<br />
					</code>

					<p>
						In SASS we have a nested way of doing this using the indentation hierarchy
					</p>

					<code>
						.container<br />
						&nbsp;&nbsp;properties...<br /><br />
						&nbsp;&nbsp;.content <br />
						&nbsp;&nbsp;&nbsp;&nbsp;properties...<br /><br />
						&nbsp;&nbsp;&nbsp;&nbsp;span <br />
						&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;properties...<br />
						<br />
					</code>

					<h4>
						Sub-property nesting
					</h4>

					<p>
						SASS takes CSS nesting to another level, allowing sub-properties to be declared as nests, here we want to declare font properties
						to a p tag.
					</p>

					<code>
						p<br />
						&nbsp;&nbsp;font<br />
						&nbsp;&nbsp;&nbsp;&nbsp;family: "Verdana"<br />
						&nbsp;&nbsp;&nbsp;&nbsp;size: 12pt<br />
						&nbsp;&nbsp;&nbsp;&nbsp;weight: normal<br />
						&nbsp;&nbsp;&nbsp;&nbsp;style: italic<br />
					</code>

					<h4>
						Mixins
					</h4>

					<p>
						Sort of like functions that can take 0 or more arguments and return a set of (possibly dynamic) CSS properties.
					</p>

					<code>
						@mixin demo<br />
						&nbsp;&nbsp;font<br />
						&nbsp;&nbsp;&nbsp;&nbsp;family: "Verdana"<br />
						&nbsp;&nbsp;&nbsp;&nbsp;size: 12pt<br />
						&nbsp;&nbsp;&nbsp;&nbsp;weight: normal<br />
						&nbsp;&nbsp;&nbsp;&nbsp;style: italic<br />
					</code>


					<div class="note">
						<em>Note: </em>
							In and of itself it does nothing, if it is not used it will <b>not be in the resulting CSS</b>, but if we want this font style to be used
						in all table cells, p tags and spans but with different colors we use it as such.
					</div>

					<code>
						p<br />
						&nbsp;&nbsp;@include demo<br />
						&nbsp;&nbsp;color: #444<br />
						td<br />
						&nbsp;&nbsp;@include demo<br />
						&nbsp;&nbsp;color: #666<br />
						span<br />
						&nbsp;&nbsp;@include demo<br />
						&nbsp;&nbsp;color: #888<br />
					</code>

					<p>
						The reason for using mixins and not only inherited selectors is that mixins can take arguments and return dynamic sets of properties.
						Here we declare a global font and size but we want the selector using the mixin to determine the color and style of the font.
					</p>

					<code>

						$font: "Verdana"<br />
						$size: 12pt<br />
						<br />
						@mixin demo($color, $style)<br />
						&nbsp;&nbsp;font<br />
						&nbsp;&nbsp;&nbsp;&nbsp;family: $font<br />
						&nbsp;&nbsp;&nbsp;&nbsp;size: $size<br />
						&nbsp;&nbsp;&nbsp;&nbsp;weight: normal<br />
						&nbsp;&nbsp;&nbsp;&nbsp;style: $style<br />
						&nbsp;&nbsp;color: $color
					</code>

					<code>
						p<br />
						&nbsp;&nbsp;@include demo(#444, normal)<br />
						td<br />
						&nbsp;&nbsp;@include demo(#666, oblique)<br />
						span<br />
						&nbsp;&nbsp;@include demo(#888, italic)<br />
					</code>

					<h4>
						Inheritance
					</h4>

					<p>
						Inheritance is used in much the same way as mixins except that they take existing selectors instead of the compilation level
						mixin definition. Here we declare a p tag style and a span tag that inherits the style of the p tag and declares its own.
					</p>

					<div class="note">
						<em>Note: </em>
							Both the p and span selectors <b>will be contained in the resulting stylesheet</b>!
					</div>

					<code>
						p<br />
						&nbsp;&nbsp;font<br />
						&nbsp;&nbsp;&nbsp;&nbsp;family: "Verdana"<br />
						&nbsp;&nbsp;&nbsp;&nbsp;size: 12pt<br />
						&nbsp;&nbsp;&nbsp;&nbsp;weight: normal<br />
						&nbsp;&nbsp;&nbsp;&nbsp;style: italic<br />
						<br />
						span<br />
						&nbsp;&nbsp;@extend p<br />
						&nbsp;&nbsp;color: #567
					</code>

				
				</div>

				<p>
					Read more on SASS <a href="www.sass-lang.com">website</a>, and more about compass and its support mixins on <a href="compass-style.com">theirs</a>.
				</p>
				
				<h3>Configuration</h3>

				<p>
					The new CSS is generated using the SASS 'pre-processor', giving it far more power while developing.
					One of these powers is variables, and with variables DOJO includes a configuration file, found under 
					dojo/config.sass.
				</p>

				<p>
					In this file you can set general configurations, such as the header height, fonts, different colors and more.
				</p>

				<h3>All img tag icons should be replaced by sprite spans</h3>

				<p>
					Ninja now uses CSS sprites instead of independent icon images, a first glance test lowered the request count from 94 -> 36 and uncached 
					load-time by 1.4 seconds. Icon images can be replaced everywhere an icon is used from the icon folders and is a PNG image.
				</p>

				<div class="warning">
					<em>(!) Warning: </em>
					GIF icons cannot be included in spritesheets by compass, use the old icon images for icons, gif icons will be updated to PNG.
				</div>

				<p>
					In order to utilize this development feature all img tags relating to icons should move from the old e.g. 
				</p>
				
				<code>
					echo html::image(<br />
					&nbsp;&nbsp;$this->add_path('icons/12x12/shield-'.strtolower($row['status']).'.png'),<br />
					&nbsp;&nbsp;array(<br />
						&nbsp;&nbsp;&nbsp;&nbsp;'title' => $row['status'], 'alt' => $row['status'], <br />
						&nbsp;&nbsp;&nbsp;&nbsp;'style' => 'margin-bottom: -2px'<br />
					&nbsp;&nbsp;)<br />
					);
				</code>

				<p>
					To the new
				</p>

				<code>
					echo '&lt;span class="icon-12 x12-'.
						<br />&nbsp;&nbsp;strtolower($row['status']).'" '.
						<br />&nbsp;&nbsp;'	title="'.$row['status'].'"&gt;&lt;/span&gt;';<br /><br />
					// The style is omitted because inline style is no-no
				</code>

				<p>
					Resulting in, maybe something like this
				</p>

				<code>
					&lt;span class="icon-12 x12-up" title="up"&gt;&lt;/span&gt;';<br />
				</code>

				<p>
					The class is broken down to
				</p>

				<table>
					<tr>
						<td>icon-12</td><td>x12-</td><td>up</td>
					</tr>
					<tr>
						<td>This is an icon and it is of size 12x12</td>
						<td>It is part of the spritesheet x12 (like all 12x12 icons)</td>
						<td>And it's the one formerly named up (up.png)</td>
					</tr>
				</table>

				<p>
					The class for icons such as shield-not-disabled would hence become:
				</p>

				<table>
					<tr>
						<td>icon-16</td><td>x16-</td><td>shield-not-disabled</td>
					</tr>
					<tr>
						<td>This is an icon and it is of size 16x16</td>
						<td>It is part of the spritesheet x16 (like all 16x16 icons)</td>
						<td>And it's the one formerly named shield-not-disabled (shield-not-disabled.png)</td>
					</tr>
				</table>

				<h3>Global Auxiliary Selectors</h3>
				
				<h4>.alpha</h4>
				<p>
					Sets the opacity of the element to 0.4 by default and nothing else, the amount it sets can be configured in the SASS configuration file.
				</p>

				<h4>.right</h4>
				<p>
					Floats the elements to the right and nothing else. Use .clear to restore.
				</p>

				<h4>.left</h4>
				<p>
					Floats the elements to the left and nothing else. Use .clear to restore.
				</p>

				<h4>.clear</h4>
				<p>
					Clears both on the element and nothing else. Always use after floated elements to restore normal flow.
				</p>

				<h4>.none (legacy .white)</h4>
				<p>
					Makes the element completely transparent by setting 0 opacity.
				</p>

				<h4>.nullify (legacy .white)</h4>
				<p>
					Removes a lot of things, this one is already in use by all tables by default.
				</p>
				<ul>
						<li>background: transparent</li>
						<li>border-spacing: 0</li>
						<li>vertical-align: top</li>
						<li>outline: none</li>
						<li>border: none</li>
						<li>margin: 0</li>
						<li>padding: 0</li>
					</ul>

			</div>
		</div>

	</body>
</html>